--------------------------------------------------------------------------------
-- Weapon Missile Battery + Projectile Missile
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
-- Improved by Vectar666
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.missilebat2={}
cc.missilebat2.missile={}

-- Load & Prepare Ressources
cc.missilebat2.gfx_wpn=loadgfx("weapons/missilebattery.bmp")				-- Weapon Image
setmidhandle(cc.missilebat2.gfx_wpn)
cc.missilebat2.gfx_pro=loadgfx("weapons/missile.bmp")					-- Projectile Image
setmidhandle(cc.missilebat2.gfx_pro)
cc.missilebat2.sfx_attack=loadsfx("rocketrelease.wav")					-- Attack Sound

--------------------------------------------------------------------------------
-- Weapon: Missile Battery
--------------------------------------------------------------------------------

cc.missilebat2.id=addweapon("cc.missilebat2","Missile Battery (Improved)",cc.missilebat2.gfx_wpn,0,3)	-- Add Weapon (0 uses, first in round 3)
cc.missilebat2.ammo=9													-- 9 Missiles

function cc.missilebat2.draw()											-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(160,200,160)
	drawinhand(cc.missilebat2.gfx_wpn,6,0)
	-- HUD ammobar
	if cc.missilebat2.ammo-weapon_shots>0 then
		hudammobar(cc.missilebat2.ammo-weapon_shots,cc.missilebat2.ammo)
	-- HUD Crosshair
		hudcrosshair(7,3)
	end
	-- HUD Timer
	if weapon_shots<7 then
		hudtimer(1,1,3)
	elseif weapon_shots<8 then
		hudtimer(1,1,2)
		if weapon_timer>2 then
			weapon_timer=2
		end
	elseif weapon_shots<9 then
		hudtimer(1,1,1)
		if weapon_timer>1 then
			weapon_timer=1
		end
	end
end

function cc.missilebat2.attack(attack)									-- Attack
	-- Decrement timer
	if cc.missilebat2.weapon_timer==nil then cc.missilebat2.weapon_timer=0 end
	if cc.missilebat2.weapon_timer>0 then
		cc.missilebat2.weapon_timer=cc.missilebat2.weapon_timer-1
	end
	if (weapon_shots<cc.missilebat2.ammo) and (attack==1) and (cc.missilebat2.weapon_timer<=0) then
		-- No more weapon switching!
		useweapon(0)
		playsound(cc.missilebat2.sfx_attack)
		weapon_shots=weapon_shots+weapon_timer
		cc.missilebat2.weapon_timer=15*weapon_timer
		if weapon_timer==1 then
			id=createprojectile(cc.missilebat2.missile.id)
			projectiles[id]={}
			-- Ignore collision with current player at beginning
			projectiles[id].ignore=playercurrent()
			-- Set initial position of projectile
			projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10.0
			-- Initial movement
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*20
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*20
			projectiles[id].x=projectiles[id].x-projectiles[id].sx
			projectiles[id].y=projectiles[id].y-projectiles[id].sy
			cc.missilebat2.missile.move(id,0)
			-- Set speed of projectile
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*10.0
		else
			for i=1,weapon_timer,1 do
				id=createprojectile(cc.missilebat2.missile.id)
				projectiles[id]={}
				-- Ignore collision with current player at beginning
				projectiles[id].ignore=playercurrent()
				-- Set initial position of projectile
				projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*10.0
				projectiles[id].y=getplayery(0)+10-(i*6)-math.cos(math.rad(getplayerrotation(0)))*10.0
				-- Initial movement
				projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*20
				projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*20
				projectiles[id].x=projectiles[id].x-projectiles[id].sx
				projectiles[id].y=projectiles[id].y-projectiles[id].sy
				cc.missilebat2.missile.move(id,0)
				-- Set speed of projectile
				projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*10.0
				projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*10.0
			end
		end
		-- Effects
		recoil(5*weapon_timer)
		-- End Turn
		if weapon_shots>=cc.missilebat2.ammo then
			endturn()
		end
	end
end

--------------------------------------------------------------------------------
-- Projectile: missile
--------------------------------------------------------------------------------

cc.missilebat2.missile.id=addprojectile("cc.missilebat2.missile")		-- Add Projectile

function cc.missilebat2.missile.draw(id)								-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(cc.missilebat2.gfx_pro,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function cc.missilebat2.missile.update(id)							-- Update
	-- Move
	cc.missilebat2.missile.move(id,1)
end

function cc.missilebat2.missile.move(id,fx)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Particle Tail
	if (fx==1) then
		particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlefadealpha(0.01)
		particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
		particlefadealpha(0.04)
	end
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()*0.5
	projectiles[id].sy=projectiles[id].sy+getgravity()*1.5
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				-- Cause damage
				arealdamage(projectiles[id].x,projectiles[id].y,70,20)
				-- Destroy terrain
				terrainexplosion(projectiles[id].x,projectiles[id].y,20,1)
				-- Crater
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				-- Free projectile
				freeprojectile(id)
				break
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			break
		end
	end
end